unit Unit2;

interface

uses windows, unit3, jpeg, sysutils, graphics, messages;

function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';
procedure OpenPic(FileName:string);
procedure PreparePic;
procedure Button3Click;
procedure Concrete(rect:trect);
function GetMid(t:trect):trgb;
procedure DrawFrame;

implementation

procedure DrawFrame;
 var i,n,m,x,y:integer;
 d1:hdc;
begin
 for i:=0 to high(rects) do  //  
  for n:=0 to rects[i].h do
   for m:=0 to rects[i].w do begin
    y:=rects[i].centr.py+n;
    x:=rects[i].centr.px+m;
    if (y>0)and(x>0)and(y<grt.Bottom)and(x<grt.Right) then begin
     ps[y,x].r:=255;
     ps[y,x].g:=255;
     ps[y,x].b:=255;
    end;
   end;

 for i:=0 to high(rects) do begin
  rects[i].centr.py:=round(rects[i].centr.y-rects[i].delta);
  rects[i].centr.px:=round(rects[i].centr.x-rects[i].delta);
  for n:=0 to rects[i].h do
   for m:=0 to rects[i].w do begin
    y:=rects[i].centr.py+n;
    x:=rects[i].centr.px+m;
    if (y>0)and(x>0)and(y<grt.Bottom)and(x<grt.Right) then begin
     ps[y,x].r:=rects[i].color.r;
     ps[y,x].g:=rects[i].color.g;
     ps[y,x].b:=rects[i].color.b;
    end;
   end;
 end;

 d1:=getdc(mainwnd);
 bitblt(d1,px+1,py+1,orw,orh,sour.Canvas.Handle,1,1,srccopy); //  
 releasedc(mainwnd,d1);
end;

procedure PreparePic;
 var i,j:integer;
begin
  sour.PixelFormat:=pf24bit;
  orw:=sour.width;
  orh:=sour.Height;

  wrt.Left:=1; //1 - 
  wrt.Right:=orw;
  wrt.Top:=1;
  wrt.Bottom:=orh;

  grt.Left:=1;
  grt.Top:=1;
  grt.Right:=orw+1;
  grt.Bottom:=orh+1;
 //////   ///////
  sha:=tbitmap.Create;
  sha.LoadFromResourceName(hinstance,'SH');
  sha.PixelFormat:=pf24bit;
  shad:=sha.Width; ///    
  sha.Height:=shad*2;//    
  sour.Width:=sour.Width+2;  //2   
  sour.Height:=sour.Height+2;
  bitblt(sour.Canvas.Handle,1,1,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy); //   1 ,     
  sour.Canvas.Pen.Width:=1;
  sour.Canvas.Pen.Color:=8486528;
  sour.Canvas.MoveTo(0,0);
  sour.Canvas.LineTo(sour.Width-1,0);
  sour.Canvas.LineTo(sour.Width-1,sour.Height-1);
  sour.Canvas.LineTo(0,sour.Height-1);
  sour.Canvas.LineTo(0,0);
  sour.Width:=sour.Width+shad;
  sour.Height:=sour.Height+shad;

  for i:=((sour.Width-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,12+i*9,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);

  ps:=nil;  //     
  setlength(ps,sha.Height);
  for i:=0 to High(ps) do ps[i]:=sha.scanline[i];

  for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[i+shad,j].r:=ps[j,i].r;
    ps[i+shad,j].g:=ps[j,i].g;
    ps[i+shad,j].b:=ps[j,i].b;
   end;

  for i:=((sour.Height-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,sour.Width-shad,12+i*9,shad,shad,sha.Canvas.Handle,0,shad,srccopy);

   for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[j,i].r:=ps[(shad*2)-j-1,i].r;
    ps[j,i].g:=ps[(shad*2)-j-1,i].g;
    ps[j,i].b:=ps[(shad*2)-j-1,i].b;
   end;
  bitblt(sour.Canvas.Handle,sour.Width-shad,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);
  sha.Free;
/////////  ////////////
  ps:=nil;  //     
  setlength(ps,sour.Height);
  for i:=0 to High(ps) do ps[i]:=sour.scanline[i];

  GetClientRect(mainwnd,r1);
  invalidaterect(mainwnd,@r1,true);
  if FileName<>'' then
   setwindowtext(mainwnd,pchar(' Reader: '+FileName))
  else  setwindowtext(mainwnd,pchar(' Reader'));
  enablewindow(but2,true);
  enablewindow(but3,true);
end;

procedure OpenPic(FileName:string);
 var ext:string;
 MyJPEG: TJPEGImage;
begin
 ext:=ExtractFileExt(FileName);
 ext:=LowerCase(ext);
 if ext='.bmp' then begin
  sour.LoadFromFile(FileName);
 end else begin // JPEG
  MyJPEG := TJPEGImage.Create;
  try
   MyJPEG.LoadFromFile(FileName);
   sour.Width:=MyJPEG.Width;
   sour.Height:=MyJPEG.Height;
   sour.Canvas.Draw(0,0,MyJPEG);
  finally
   MyJPEG.Free;
  end;
 end;

 if (sour.width>23)and(sour.Height>23) then begin 
  PreparePic;
 end else begin
  sour.Width:=0;
  sour.Height:=0;
  enablewindow(but3,false);
  enablewindow(but2,false);
  messagebox(mainwnd,'Picture is too small','Error',MB_OK+MB_ICONWARNING);
 end; 
end;

procedure Button3Click;
 var i,j,b,c,k:cardinal;
 co:trgb;
 mc,x,y:extended; // 
begin
////  //////
 co:=GetMid(wrt);
 mc:=sqrt(co.r*co.r+co.g*co.g+co.b*co.b);
/////////        //////
 b:=0;
 c:=0;
 for i:=wrt.Top to wrt.Bottom do
  for j:=wrt.Left to wrt.Right do begin
   if sqrt(ps[i,j].r*ps[i,j].r+ps[i,j].g*ps[i,j].g+ps[i,j].b*ps[i,j].b)<mc then
    inc(b) //     
   else
    inc(c);
  end;
 if c>b then begin
  count:=b;
  b:=0;
  c:=255;
 end else begin
  count:=c;
  b:=255;
  c:=0;
 end;

 for i:=wrt.Top to wrt.Bottom do
  for j:=wrt.Left to wrt.Right do begin
   if sqrt(ps[i,j].r*ps[i,j].r+ps[i,j].g*ps[i,j].g+ps[i,j].b*ps[i,j].b)<mc then begin
    ps[i,j].r:=b;
    ps[i,j].g:=b;
    ps[i,j].b:=b;
   end else begin
    ps[i,j].r:=c;
    ps[i,j].g:=c;
    ps[i,j].b:=c;
   end;
  end;

 rects:=nil;
 Concrete(wrt);  //     

 if rects<>nil then begin
  k:=length(rects);
  if k<3000 then begin
   dists:=nil;
   setlength(dists,k,k);
   for i:=0 to high(rects)-1 do
    for j:=i+1 to high(rects) do begin
     x:=rects[i].centr.x-rects[j].centr.x;
     y:=rects[i].centr.y-rects[j].centr.y;
     dists[i,j]:=sqrt((x*x)+(y*y));
    end;
  end else begin
   messagebox(mainwnd,'There is too much squares','Error',MB_OK+MB_ICONWARNING);
   postmessage(but3,WM_KEYDOWN,32,0);
   postmessage(but3,WM_KEYUP,32,0);
  end;
 end else begin
  postmessage(but3,WM_KEYDOWN,32,0);
  postmessage(but3,WM_KEYUP,32,0);
 end;
 setwindowtext(mainwnd,pchar('squares - '+inttostr(length(rects))));
end;

function GetMid(t:trect):trgb;
 var i,j:integer;
     r,g,b:int64;
begin
 r:=0;
 g:=0;
 b:=0;
 for i:=t.Top to t.Bottom do
  for j:=t.Left to t.Right do begin
   r:=r+ps[i,j].r;
   g:=g+ps[i,j].g;
   b:=b+ps[i,j].b;
  end;
 i:=(t.Bottom-t.Top+1)*(t.Right-t.Left+1);
 result.r:=r div i;
 result.g:=g div i;
 result.b:=b div i;
end;

procedure Concrete(rect:trect);
 function GetMiddle(t:trect):extended;
  var i,j:integer;
 begin
  result:=0;
  for i:=t.Top to t.Bottom do
   for j:=t.Left to t.Right do
    result:=result+ps[i,j].r;
  result:=result/((t.Bottom-t.Top+1)*(t.Right-t.Left+1));
 end;
                                                    
 var bal:extended;                    // 1 2
     rec1,rec2,rec3,rec4,rec5:trect;  // 3 4
     w,h:integer; 
     trigger:boolean;
begin
 trigger:=false; //     
 w:=rect.Right-rect.Left; //     (-1)
 h:=rect.Bottom-rect.Top;
 if w>h then begin //     , ...
  rec5.Right:=rect.Right;
  rect.right:=rect.Left+h; //    
  trigger:=true;
  rec5.Left:=rect.right+1; //    
  rec5.Top:=rect.Top;
  rec5.Bottom:=rect.Bottom;
  w:=h;
 end;
 if w<h then begin
  rec5.Bottom:=rect.Bottom;
  rect.Bottom:=rect.Top+w;
  trigger:=true;
  rec5.Left:=rect.Left;
  rec5.Top:=rect.Bottom+1;
  rec5.Right:=rect.Right;
  h:=w;  
 end;

 bal:=GetMiddle(rect); //     R  

 if bal=0 then begin  //   
  setlength(rects,length(rects)+1); //  
  rects[high(rects)].w:=w;
  rects[high(rects)].h:=h;
  rects[high(rects)].delta:=w/2;
  rects[high(rects)].centr.x:=rect.Left+rects[high(rects)].delta;
  rects[high(rects)].centr.y:=rect.Top+rects[high(rects)].delta;
  rects[high(rects)].centr.px:=round(rects[high(rects)].centr.x-rects[high(rects)].delta);
  rects[high(rects)].centr.py:=round(rects[high(rects)].centr.y-rects[high(rects)].delta);
  rects[high(rects)].centr.mass:=(w+1)*(h+1);
  rects[high(rects)].centr.dx:=5;
  rects[high(rects)].centr.dy:=0;
  if col then begin
   rects[high(rects)].color.r:=random(220);
   rects[high(rects)].color.g:=random(220);
   rects[high(rects)].color.b:=random(220);
  end else begin
   rects[high(rects)].color.r:=0;
   rects[high(rects)].color.g:=0;
   rects[high(rects)].color.b:=0;
  end;

  if trigger then Concrete(rec5);
  exit;
 end;

 if bal=255 then begin   // 
  if trigger then Concrete(rec5);
  exit;
 end;

 rec1.Top:=rect.Top;
 rec1.Left:=rect.Left;
 rec1.Right:=rec1.Left+(w div 2);
 rec1.Bottom:=rec1.Top+(h div 2);

 rec2.Top:=rect.Top;
 rec2.Left:=rec1.Right+1;
 rec2.Right:=rect.Right;
 rec2.Bottom:=rec1.Bottom;

 rec3.Top:=rec1.Bottom+1;
 rec3.Left:=rect.Left;
 rec3.Right:=rec1.Right;
 rec3.Bottom:=rect.Bottom;

 rec4.Top:=rec3.Top;
 rec4.Left:=rec2.Left;
 rec4.Right:=rect.Right;
 rec4.Bottom:=rect.Bottom;

 concrete(rec1);
 concrete(rec2);
 concrete(rec3);
 concrete(rec4);

 if trigger then Concrete(rec5);
end;

end.
